package 
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.BitmapData
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.geom.ColorTransform;
	import flash.net.FileReference
	import flash.display.Loader
	import flash.display.Bitmap
	import flash.display.MovieClip
	import fl.controls.ColorPicker	
	import flash.events.MouseEvent
	import KeyObject
	
	public class  CustomCharacter extends Sprite
	{
		var myColorPicker:ColorPicker = new ColorPicker();
		var myChangedObject:MovieClip;
		var bucket:Boolean = false
		var drawableParts:Array 
		var drawing:Boolean = false
		var pencilColor:String = "000000"
		var key:KeyObject;
		public function CustomCharacter():void {
		
		tools.playing.visible = false;	
			
		drawableParts = [player.arm1,player.arm2,player.leg1,player.leg2,player.head,player.shirt,player.hair]
		myColorPicker.editable = true;
		myColorPicker.visible = false;
		addChild(myColorPicker);
		
		
		tools.bucket.visible = false;
		tools.pencil.visible = false;
		
		tools.bucket_btn.addEventListener(MouseEvent.CLICK,enableBucket)
		tools.pencil_btn.addEventListener(MouseEvent.CLICK, enablePencil)
		
		
		tools.playgame.addEventListener(MouseEvent.CLICK,enableGame)
		player.stop()

		for (var i:int = 0; i < drawableParts.length;i++ ) {
			
			var myShape:Shape = new Shape()
			
			
			myShape.name = "shapes"
			
			drawableParts[i].addChild(myShape)
			myShape.mask = drawableParts[i].maskclip
			
			
			

			
		}

		tools.reset.addEventListener(MouseEvent.CLICK,resetEverything)
		key = new KeyObject(stage);
		
		
		}
		
		private function enableGame(e:MouseEvent):void 
		{
			tools.playing.visible = !tools.playing.visible

			if (tools.playing.visible) {
				
				player.play()
				addEventListener(Event.ENTER_FRAME, enterFrame);
				myColorPicker.editable = false;
				myColorPicker.x = 10000
			}
			else {
				
				player.gotoAndStop(1)
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				if (tools.pencil.visible) {
					
					myColorPicker.x = 440
				}


			}
		}
		
		private function enterFrame(e:Event):void 
		{
			if (key.isDown(key.LEFT) && player.x > 0) { 
			
				player.x -= 5;
				player.scaleX = -1
				
			
			}
			if (key.isDown(key.RIGHT) && player.x < 640) {
				
				player.x += 5
				player.scaleX = 1
			}
		}
		
		
		private function resetEverything(e:MouseEvent):void 
		{
			for (var i:int = 0; i < drawableParts.length; i++ ) {
				drawableParts[i].removeChild(drawableParts[i].getChildByName("shapes"));
				
				var myShape:Shape = new Shape()
				myShape.name = "shapes"
				drawableParts[i].addChild(myShape)
				myShape.mask = drawableParts[i].maskclip
				
				
				drawableParts[i].getChildByName("color").transform.colorTransform = new ColorTransform()
			
			}
			

		}
		
		
		private function enablePencil(e:MouseEvent):void 
		{
			
		tools.bucket.visible = false;
		tools.pencil.visible = true;
		player.removeEventListener(MouseEvent.CLICK, showPicker)
		myColorPicker.removeEventListener(Event.CHANGE, colorChanged)
		myColorPicker.addEventListener(Event.CHANGE, colorChangedPencil)
		player.addEventListener(MouseEvent.MOUSE_DOWN, drawOnPlayer)
		player.addEventListener(MouseEvent.MOUSE_UP, dontDrawOnPlayer)
		player.addEventListener(MouseEvent.MOUSE_MOVE, moveDrawOnPlayer)



			myColorPicker.visible = true
			myColorPicker.move(440, 20);
		
		
		}
		
		private function moveDrawOnPlayer(e:MouseEvent):void 
		{
			if (e.target.name == "color" && drawing) {
					
					e.target.parent.getChildByName("shapes").graphics.lineTo(e.target.parent.getChildByName("shapes").mouseX,e.target.parent.getChildByName("shapes").mouseY);

				
			}

		}
		
		private function dontDrawOnPlayer(e:MouseEvent):void 
		{
			
			drawing = false;
			
		}

		
		private function drawOnPlayer(e:MouseEvent):void 
		{

			drawing = true;
			if (e.target.name == "color" ) {
					e.target.parent.getChildByName("shapes").graphics.lineStyle(10, uint("0x"+pencilColor))
					e.target.parent.getChildByName("shapes").graphics.moveTo(e.target.parent.getChildByName("shapes").mouseX, e.target.parent.getChildByName("shapes").mouseY);
			}

			

		}
		
		private function enableBucket(e:MouseEvent):void 
		{
		
		tools.bucket.visible = true;
		tools.pencil.visible = false;
		myColorPicker.visible = false
		player.removeEventListener(MouseEvent.MOUSE_DOWN, drawOnPlayer)
		player.removeEventListener(MouseEvent.MOUSE_UP, dontDrawOnPlayer)
		myColorPicker.removeEventListener(Event.CHANGE, colorChangedPencil)
		player.addEventListener(MouseEvent.CLICK, showPicker)
		myColorPicker.addEventListener(Event.CHANGE, colorChanged)
		player.removeEventListener(MouseEvent.MOUSE_DOWN, drawOnPlayer)
		player.removeEventListener(MouseEvent.MOUSE_UP, dontDrawOnPlayer)
		player.removeEventListener(MouseEvent.MOUSE_MOVE, moveDrawOnPlayer)

		
		}
		
		private function colorChangedPencil(e:Event):void 
		{
			pencilColor = e.target.hexValue
			
		}
		
		private function colorChanged(e:Event):void 
		{
			myColorPicker.visible = false;
			var myChange:ColorTransform = new ColorTransform();
			myChange.color = new uint("0x" + e.target.hexValue)
			myChangedObject.transform.colorTransform = myChange
		}
		
		private function showPicker(e:MouseEvent):void 
		{
			if (e.target.name == "color") {
			myColorPicker.visible = !myColorPicker.visible 
			myColorPicker.move(stage.mouseX, stage.mouseY)
			myChangedObject = MovieClip(e.target)
			myColorPicker.selectedColor = uint(myChangedObject.transform.colorTransform.color)

			}
			
		}
		
		
		
		
	}
	
	
	
}